#######################################
## Data analisys fruit and vegetables #
#######################################
library ("Hmisc")
library ("dplyr")
library ("reshape2")
library("ggplot2")
library ("RColorBrewer")
library("tidyr")
library("grid") 
library("gridExtra") 
library ("viridis")
library ("ggthemes")

###############################
## Updating AGRONET database ##
##############################
# getwd()
# setwd("~/Google Drive/Mi unidad/2. ITA/R files mac") ## abrir ubicacion de la carpeta de trabajo
# prod.18 <- read.delim ("db.prod.18.txt", dec = ".")# cargar archivo con datos
# prod.20 <- read.delim ("db.prod.20.txt", dec=",")
# prod.20$depa = toupper(prod.20$depa)
# prod.20$muni = toupper(prod.20$muni)
# prod.20$gr.culti = toupper(prod.20$gr.culti)
# prod.20$subgr.culti = toupper(prod.20$subgr.culti)
# prod.20$culti = toupper(prod.20$culti)
# prod.20$tipo.culti = toupper(prod.20$tipo.culti)
# prod.20$cod.depa <- as.factor (prod.20$cod.depa) # asignar categoria de factor a las columna

# prod.all <- union (prod.18, prod.20)
# write.table (prod.all, "prod.07-20.txt", sep="\t", dec=",")
###########

## Data analysis
## Complete database
getwd()
setwd("~/Library/CloudStorage/OneDrive-Personal/Documentos/Sebastian/Academia/4. Data science/R projects")
prod.20 <- read.delim ("prod.07-20.txt", dec=",")
str (prod.20) 
names (prod.20) 
prod.20$cod.depa <- as.factor (prod.20$cod.depa) 
prod.20$depa <- as.factor (prod.20$depa) 
prod.20$cod.muni <- as.factor (prod.20$cod.muni) 
prod.20$muni <- as.factor (prod.20$muni) 
prod.20$gr.culti <- as.factor (prod.20$gr.culti) 
prod.20$subgr.culti <- as.factor (prod.20$subgr.culti) 
prod.20$culti <- as.factor (prod.20$culti) 
#prod.20$anho <- as.factor (prod.20$anho)
prod.20$period <- as.factor (prod.20$period) 
prod.20$tipo.culti <- as.factor (prod.20$tipo.culti) 

prod.20$ar.semb <- as.numeric (prod.20$ar.semb) 
prod.20$ar.cose <- as.numeric (prod.20$ar.cose) 
prod.20$produ <- as.numeric (prod.20$produ) 
prod.20$rendi <- as.numeric (prod.20$rendi) 

str (prod.20) 

## ANALISIS DE FRUTALES Y HORTALIZAS PARA PUBLICACION
## Eliminación de outliers base de datos productividad objeto prod.20

prod.20.fh <- filter (prod.20, gr.culti =="FRUTALES"|gr.culti=="HORTALIZAS") 
levels (prod.20.fh$gr.culti) <- c("Cereals","Tropical crops", "fibers", 
                                  "Flowers", "Trees", "Fruits", "Fungi", "Vegetables", 
                                  "Legumes", "Legumes and oil", "Oilseeds", 
                                  "Others 1", "Others 2", "Spicy and medicinas", 
                                  "Plantains", "Tubers")




source ("Function outliers.r") 
names(prod.20.fh)
ar.semb.o <- as.data.frame(remove_outliers (prod.20.fh$ar.semb))
ar.cose.o <- as.data.frame(remove_outliers (prod.20.fh$ar.cose))
produ.o <- as.data.frame(remove_outliers (prod.20.fh$produ))
rendi.o <- as.data.frame(remove_outliers (prod.20.fh$rendi))

prod.20.f <- select (prod.20.fh, depa, muni, gr.culti, culti,anho)
prod.20.fh <- bind_cols (prod.20.f, ar.semb.o, 
                               ar.cose.o, produ.o, rendi.o)

names (prod.20.fh)


names (prod.20.fh) [6] <- paste ("ar.semb")
names (prod.20.fh) [7] <- paste ("ar.cose")
names (prod.20.fh) [8] <- paste ("produ")
names (prod.20.fh) [9] <- paste ("rendi")


## Analisis de tendencias nacional en los ultimos años
prod.20.fh <- prod.20.fh %>% group_by (depa, gr.culti) # agrupacion de los datos de la tabla prod.18 por departamentos y grupos de cultivos 
prod.20.sum.nal <-  summarise_each(prod.20.fh, funs(mean(.,na.rm = TRUE)))# Calculo del promedio para las variables de acuerdo a la agrupación hecha antriormente

nal.frut <- subset (prod.20.sum.nal, gr.culti =="Fruits") # Crear una nueva tabla a partir de la que contiene los promedios solamente con la información para frutales 
nal.hort <- subset (prod.20.sum.nal, gr.culti =="Vegetables")  # Crear una nueva tabla a partir de la que contiene los promedios solamente con la información para hortalizas
#nal.cere <- subset (prod.20.sum.nal, gr.culti =="CEREALES")
#nal.olea <- subset (prod.20.sum.nal, gr.culti =="OLEAGINOSAS")
#nal.legu <- subset (prod.20.sum.nal, gr.culti =="LEGUMINOSAS")
#nal.tuber.pla <- subset (prod.20.sum.nal, gr.culti =="TUBERCULOS Y PLATANOS")
#nal.aro.med <- subset (prod.20.sum.nal, gr.culti =="PLANTAS AROMATICAS, CONDIMENTARIAS Y MEDICINALES")

ungroup (prod.20.fh) # desagrupar los datos de la tabla prod.20
prod.20.fh <- prod.20.fh %>% group_by (gr.culti) # agrupar datos de la tabla prod.20 por grupo de cultivos para calcular promedio nacional 
prom.nal <- summarise_each(prod.20.fh, funs(mean(.,na.rm = TRUE))) # calculo del promedio nacional por grupos de cultivos  

ungroup (prod.20.fh) # desagrupar los datos de la tabla prod.20
prod.20.fh <- prod.20.fh %>% group_by (anho, gr.culti) # agrupar datos de la tabla prod.20 por grupo de cultivos para calcular promedio nacional 
prom.nal.anho <- summarise_each(prod.20.fh, funs(mean(.,na.rm = TRUE))) # calculo del promedio nacional por grupos de cultivos  

## Figura distrubución de frecuencias variables cuantitativas
ggplot (prod.20.fh, aes(ar.semb)) + 
  geom_histogram(binwidth=2, colour="dodgerblue", fill="dodgerblue", alpha=1) + 
  theme_bw() + xlab (expression (paste ('Cultivated area'~(ha))))

ggplot (prod.20.fh, aes(ar.cose)) + 
  geom_histogram(binwidth=25, colour="dodgerblue", fill="dodgerblue", alpha=0.8) + 
  theme_bw() + xlab (expression (paste ('Harvest area'~(ha))))

ggplot (prod.20.fh, aes(produ)) + 
  geom_histogram(binwidth=80, colour="dodgerblue", fill="dodgerblue", alpha=0.8) + 
  theme_bw() + xlab (expression (paste ('Production'~(Ton))))

ggplot (prod.20.fh, aes(rendi)) + 
  geom_histogram(binwidth=2, colour="dodgerblue", fill="dodgerblue", alpha=0.8) + 
  theme_bw() + xlab (expression (paste ('Yield'~(Ton~x~ha^-1))))



## Box plot figura articulo
names (prod.20.fh)

p1 <- ggplot(prod.20.fh, aes(x=gr.culti, y=ar.semb, fill=gr.culti)) +
  geom_boxplot(alpha=1,colour="black") +
  stat_summary(fun.y=mean, geom="point", col="Black", shape = 10, size=5) +
  theme_bw() + # facet_grid(. ~ gr.culti, scales = "free", space = "free") +
  scale_fill_brewer(name="Tipo de Cultivo", palette = "Blues") + 
  ylab (expression(paste('Cultivated area'~(ha)))) + xlab (expression(paste(''))) +
  theme (strip.text.y = element_text (face="bold", size=14, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12), 
         axis.text.x = element_text(angle = 90),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

p2 <-ggplot(prod.20.fh, aes(x=gr.culti, y=ar.cose, fill=gr.culti)) +
  #geom_point(size=2) +
  #geom_line() +
  geom_boxplot(alpha=1,colour="black") +
  stat_summary(fun.y=mean, geom="point", col="Black", shape = 10, size=5) +
  theme_bw() + # facet_grid(. ~ gr.culti, scales = "free", space = "free") +
  scale_fill_brewer(name="Tipo de Cultivo", palette = "Blues") + 
  ylab (expression(paste('Harvest area'~(ha)))) + xlab (expression(paste(''))) +
  theme (strip.text.y = element_text (face="bold", size=14, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12), 
         axis.text.x = element_text(angle = 90),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

p3 <-ggplot(prod.20.fh, aes(x=gr.culti, y=produ, fill=gr.culti)) +
  #geom_point(size=2) +
  #geom_line() +
  geom_boxplot(alpha=1,colour="black") +
  stat_summary(fun.y=mean, geom="point", col="Black", shape = 10, size=5) +
  theme_bw() + # facet_grid(. ~ gr.culti, scales = "free", space = "free") +
  scale_fill_brewer(name="Tipo de Cultivo", palette = "Blues") + 
  ylab (expression(paste('Producction'~(Ton)))) + xlab (expression(paste(''))) +
  theme (strip.text.y = element_text (face="bold", size=14, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12), 
         axis.text.x = element_text(angle = 90),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")


p4 <-ggplot(prod.20.fh, aes(x=gr.culti, y=rendi, fill=gr.culti)) +
  #geom_point(size=2) +
  #geom_line() +
  geom_boxplot(alpha=1,colour="black") +
  stat_summary(fun.y=mean, geom="point", col="Black", shape = 10, size=5) +
  theme_bw() + # facet_grid(. ~ gr.culti, scales = "free", space = "free") +
  scale_fill_brewer(name="Tipo de Cultivo", palette = "Blues") + 
  ylab (expression(paste('Yield'~(Ton~x~ha^-1)))) + xlab (expression(paste(''))) +
  theme (strip.text.y = element_text (face="bold", size=14, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12), 
         axis.text.x = element_text(angle = 90),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")


png ("Figure 1. Data distribution.png",  width = 800, height = 800, dpi = 300)
grid.arrange(p1,p2,p3,p4, 
             layout_matrix = rbind(c(1,2), c(3,4)))  #crear grafica con varias figuras
graphics.off()



## promedio nacional por año frutales y hortalizas

names (prom.nal.anho)
reshape.arsem.anho <- melt(prom.nal.anho[,c(1:2, 6)], id=c("gr.culti","anho")) ## transformar la tabla para realizar figuras de area
reshape.arcos.anho <- melt(prom.nal.anho[,c(1:2, 7)], id=c("gr.culti","anho")) ## transformar la tabla para realizar figuras de area
reshape.pro.anho <- melt(prom.nal.anho[,c(1:2, 8)], id=c("gr.culti","anho")) ## transformar la tabla para realizar figuras de area
reshape.rendi.anho <- melt(prom.nal.anho[,c(1:2, 9)], id=c("gr.culti","anho")) ## transformar la tabla para realizar figuras de area

## Crear figuras de linea y puntos
## Tendencias promedios area sembrada por año, tipo de cultivos y departamentos seleccionados
p5 <- ggplot(data=reshape.arsem.anho) +
  geom_line(aes(x = anho, y = value, colour=gr.culti),
            alpha=1, size=0.8) +
  geom_point(aes(x = anho, y = value), colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(aes(x = anho, y = value, colour=gr.culti), shape=16, size = 4) +
  #position="identity") +  #this means not stacked
  scale_colour_brewer(name="Crop", palette= "Blues") +
  #scale_fill_brewer(name="Cultivos", palette="Pastel1") +
  #ylim(origin,horizonscale) +   #limit plot to origin and horizonscale
  #this is optional, but I prefer to default
  xlab (expression (paste (''))) +
  ylab (expression (paste ('Cultivated area'~(ha)))) +
  theme_bw() + scale_x_continuous (breaks=c(2006,2007,2008,2009,2010,2011,2012,2013,
                                            2014,2015,2016,2017,2018,2019,2020)) +
  theme (strip.text.y = element_text (face="bold", size=12, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=14, angle=90), 
         legend.position="",
         panel.grid.minor.x=element_blank(),
         panel.grid.minor.y=element_blank())

p6 <- ggplot(data=reshape.arcos.anho) +
  geom_line(aes(x = anho, y = value, colour=gr.culti),
            alpha=0.8, size=0.8) +
  geom_point(aes(x = anho, y = value), colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(aes(x = anho, y = value, colour=gr.culti), shape=16, size = 4) +
  #position="identity") +  #this means not stacked
  scale_colour_brewer(name="Crop", palette= "Blues") +
  #scale_fill_brewer(name="Cultivos", palette="Pastel1") +
  #ylim(origin,horizonscale) +   #limit plot to origin and horizonscale
  #this is optional, but I prefer to default
  xlab (expression (paste (''))) +
  ylab (expression (paste ('Harvest area'~(ha)))) +
  theme_bw() + scale_x_continuous (breaks=c(2006,2007,2008,2009,2010,2011,2012,2013,
                                            2014,2015,2016,2017,2018,2019,2020)) +
  theme (strip.text.y = element_text (face="bold", size=12, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=14, angle=90), 
         legend.position="none",
         panel.grid.minor.x=element_blank(),
         panel.grid.minor.y=element_blank())

p7 <- ggplot(data=reshape.pro.anho) +
  geom_line(aes(x = anho, y = value, colour=gr.culti),
            alpha=0.8, size=0.8) +
  geom_point(aes(x = anho, y = value), colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(aes(x = anho, y = value, colour=gr.culti), shape=16, size = 4) +
  #position="identity") +  #this means not stacked
  scale_colour_brewer(name="Crop", palette= "Blues") +
  #scale_fill_brewer(name="Cultivos", palette="Pastel1") +
  #ylim(origin,horizonscale) +   #limit plot to origin and horizonscale
  #this is optional, but I prefer to default
  xlab (expression (paste (''))) +
  ylab (expression (paste ('Producction'~(Ton)))) +
  theme_bw() + scale_x_continuous (breaks=c(2006,2007,2008,2009,2010,2011,2012,2013,
                                            2014,2015,2016,2017,2018,2019,2020)) +
  theme (strip.text.y = element_text (face="bold", size=12, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=14, angle=90), 
         legend.position="bottom",
         panel.grid.minor.x=element_blank(),
         panel.grid.minor.y=element_blank())

p8 <- ggplot(data=reshape.rendi.anho) +
  geom_line(aes(x = anho, y = value, colour=gr.culti),
            alpha=0.8, size=0.8) +
  geom_point(aes(x = anho, y = value), colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(aes(x = anho, y = value, colour=gr.culti), shape=16, size = 4) +
  #position="identity") +  #this means not stacked
  scale_colour_brewer(name="Crop", palette= "Blues") +
  #scale_fill_brewer(name="Cultivos", palette="Pastel1") +
  #ylim(origin,horizonscale) +   #limit plot to origin and horizonscale
  theme_bw() + #this is optional, but I prefer to default
  xlab (expression (paste (''))) +
  ylab (expression (paste ('Yield'~(Ton~x~ha^-1)))) +
  theme_bw() + scale_x_continuous (breaks=c(2006,2007,2008,2009,2010,2011,2012,2013,
                                            2014,2015,2016,2017,2018,2019,2020)) +
  theme (strip.text.y = element_text (face="bold", size=12, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=14, angle=90), 
         legend.position="bottom",
         panel.grid.minor.x=element_blank(),
         panel.grid.minor.y=element_blank())


png ("2. Tendencia Promedio nacional  frut y hort.png",  width = 800, height = 600, pointsize = 10)
grid.arrange(p5,p6,p7,p8, 
             layout_matrix = rbind(c(1,2), c(3,4)))  #crear grafica con varias figuras
graphics.off()


## promedio nacional frutales y hortalizas por departamento
## Elaboración de figuras con el promedio nacional para frutales
nal.frut$depa <- factor(nal.frut$depa, 
                        levels=nal.frut$depa[order(nal.frut$ar.semb)]) ## organizar los datos deacuerdo al valor, de mayor a menor

# Figura de puntos para el promedio de area sembrada de frutales por departamentos
p9 <- ggplot(nal.frut, aes(ar.semb, depa)) + 
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(colour = "dodgerblue", shape=16, size = 4) + 
  geom_vline(xintercept = 97.82, linetype="solid", 
             color = "dodgerblue", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Area sembrada'~(Hectareas)))) + 
  #scale_colour_manual (name="Cultivo", values=c("#00AFBB", "#FC4E07", "#00AFBB")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=12), 
         axis.text = element_text(size=10), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## promedio nacional frutales
nal.frut$depa <- factor(nal.frut$depa, 
                        levels=nal.frut$depa[order(nal.frut$produ)]) ## organizar los datos deacuerdo al valor, de mayor a menor

# Figura de puntos para el promedio produccion de frutales por departamentos
p10 <- ggplot(nal.frut, aes(produ, depa)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(colour = "dodgerblue", shape=16, size = 4) + 
  geom_vline(xintercept = 1366.73, linetype="solid", 
             color = "dodgerblue", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Produccion'~(Toneladas)))) + 
  #scale_colour_manual (name="Cultivo", values=c("#00AFBB", "#FC4E07", "#00AFBB")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=12), 
         axis.text = element_text(size=10), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## promedio nacional frutales
nal.frut$depa <- factor(nal.frut$depa, 
                        levels=nal.frut$depa[order(nal.frut$rendi)])## organizar los datos deacuerdo al valor, de mayor a menor

# Figura de puntos para el promedio de rendimiento de frutales por departamentos
p11 <- ggplot(nal.frut, aes(rendi, depa)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(colour = "Lightblue1", shape=16, size = 4) + 
  geom_vline(xintercept = 10.37, linetype="solid", 
             color = "black", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Fruits yield'~(ton~x~ha^-1)))) + 
  #scale_colour_manual (name="Cultivo", values=c("#00AFBB", "#FC4E07", "#00AFBB")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=14), 
         axis.text = element_text(size=12), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())


## promedio nacional area sembrada hortalizas
nal.hort$depa <- factor(nal.hort$depa, 
                        levels=nal.hort$depa[order(nal.hort$ar.semb)])## organizar los datos deacuerdo al valor, de mayor a menor

# Figura de puntos para el promedio de area sembrada de hortalizas por departamentos
p12 <- ggplot(nal.hort, aes(ar.semb, depa)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(colour = "orangered", shape=16, size = 4) + 
  geom_vline(xintercept = 31.43, linetype="solid", 
             color = "orangered", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Area sembrada'~(Hectareas)))) + 
  #scale_colour_manual (name="Cultivo", values=c("#00AFBB", "#FC4E07", "#00AFBB")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=12), 
         axis.text = element_text(size=10), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## promedio nacional produccion hortalizas
nal.hort$depa <- factor(nal.hort$depa, 
                        levels=nal.hort$depa[order(nal.hort$produ)]) ## organizar los datos deacuerdo al valor, de mayor a menor

# Figura de puntos para el promedio de produccion de hortalizas por departamentos
p13 <- ggplot(nal.hort, aes(produ, depa)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(colour = "orangered", shape=16, size = 4) + 
  geom_vline(xintercept = 687.59, linetype="solid", 
             color = "orangered", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Produccion'~(Toneladas)))) + 
  #scale_colour_manual (name="Cultivo", values=c("#00AFBB", "#FC4E07", "#00AFBB")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=12), 
         axis.text = element_text(size=10), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## promedio nacional rendimiento hortalizas
nal.hort$depa <- factor(nal.hort$depa, 
                        levels=nal.hort$depa[order(nal.hort$rendi)])## organizar los datos deacuerdo al valor, de mayor a menor

# Figura de puntos para el promedio de rendimiento de hortalizas por departamentos
p14 <- ggplot(nal.hort, aes(rendi, depa)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(colour = "Lightblue2", shape=16, size = 4) + 
  geom_vline(xintercept = 13.82, linetype="solid", 
             color = "black", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Vegetables yield'~(Ton~x~ha^-1)))) + 
  #scale_colour_manual (name="Cultivo", values=c("#00AFBB", "#FC4E07", "#00AFBB")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=14), 
         axis.text = element_text(size=12), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())


png ("3.Comparacion REN por depa.png",  width = 1000, height = 500, pointsize = 20)
grid.arrange(p11,p14, 
             layout_matrix = rbind(c(1,2)))  #crear grafica con varias figuras
graphics.off()


## Mejores frutales y hortalizas en el Colombia
ungroup (prod.20.fh)
prod.20.fh <- prod.20.fh %>% group_by (culti, gr.culti)
nal.culti <-  summarise_each(prod.20.fh, funs(mean(.,na.rm = TRUE)))


nal.culti$culti <- factor(nal.culti$culti, 
                          levels=nal.culti$culti[order(nal.culti$ar.semb)])## organizar los datos deacuerdo al valor, de mayor a menor

nal.culti.top.1 <- nal.culti %>%                                      
  arrange(desc(ar.semb)) %>% 
  group_by(gr.culti) %>%
  slice(1:10)

p13 <- ggplot(nal.culti.top.1, aes(ar.semb, culti)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(aes(colour = gr.culti), shape=16, size = 4) + 
  #geom_vline(xintercept = 16.9, linetype="solid", 
  #color = "forestgreen", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Area sembrada'~(Ha)))) + 
  scale_colour_manual (name="Tipo de cultivo", values=c("forestgreen", "gold"),
                       breaks=) + 
  theme_light() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=10, face="bold"), 
         axis.text = element_text(size=8, face="bold"), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())


nal.culti$culti <- factor(nal.culti$culti, 
                          levels=nal.culti$culti[order(nal.culti$produ)])## organizar los datos deacuerdo al valor, de mayor a menor

nal.culti.top.2 <- nal.culti %>%                                      
  arrange(desc(produ)) %>% 
  group_by(gr.culti) %>%
  slice(1:10)

p14 <- ggplot(nal.culti.top.2, aes(produ, culti)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(aes(colour = gr.culti), shape=16, size = 4) + 
  #geom_vline(xintercept = 16.9, linetype="solid", 
  #color = "forestgreen", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Produccion'~(Ton)))) + 
  scale_colour_manual (name="Tipo de cultivo", values=c("dodgerblue", "orangered")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=10), 
         axis.text = element_text(size=8), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())


nal.culti$culti <- factor(nal.culti$culti, 
                          levels=nal.culti$culti[order(nal.culti$rendi)])## organizar los datos deacuerdo al valor, de mayor a menor

nal.culti.top.3 <- nal.culti %>%                                      
  arrange(desc(rendi)) %>% 
  group_by(gr.culti) %>%
  slice(1:10)

levels (nal.culti.top.3$culti)

levels (nal.culti.top.3$culti) <- c("COROZO","COCONA","CAIMO","UVA CAIMARONA","RAMBUTAN",         
"MACADAMIA","GUAMA","NONI","BOROJO","COPOAZU",
"ANON","ARAZA","BACURI","PEPA DE PAN","ESPARRAGO",        
"FRAMBUESA","CHIRIMOYA","CHONTADURO","MARANHON","MAMEY",            
"UMARI","TAMARINDO","ASAI","ALGARROBO","DATIL",            
"BREVO","CILANTRO","COL","HORTALIZAS VARIAS", "NISPERO",          
"MANGOSTINO","AGRAZ","MAMONCILLO","TORONJA","FRUTALES VARIOS",  
"ARANDANO","NABO","FEIJOA","COCO","PALMITO",          
"MORA","AJI","BANANITO","POMARROSA","ZAPOTE",           
"AGUACATE","CADUCIFOLIOS","CIRUELA","GUANABANA","PITAHAYA",         
"LULO","CHOLUPA","LIMON","HIGO","GUAYABA",
"CURUBA","PAPAYUELA","GRANADILLA","MANZANA","CALABACIN",        
"BANANO","UVA","MANGO","AJO","DURAZNO",          
"PEPINO GUISO","TANGELO","TOMATE DE ARBOL","GULUPA","ALCACHOFA",        
"NARANJA","PERA","GULUPA O CHOLUPA",  "BERENJENA","AGUAJE",           
"UCHUVA","ACELGA","CHAMBA","CEBOLLA DE RAMA","AHUYAMA",
"CEBOLLIN","PIMENTON","MANDARINA","OTHER CITRUS","WATERMELON",          
"GUATILA","LIME","CALABAZA","BADEA","MELON",
"PASSION FRUIT","PEPINO COHOMBRO","ESPINACA","RABANO","CELERY",             
"PINEAPPLE","LETTUCE", "GRAPEFRUIT","STRAWBERRY","BROCCOLI",
"ONION","PAPAYA", "BEET","TOMATO","CABBAGE",          
"LEEK","CARROT", "CAULIFLOWER")

p15 <- ggplot(nal.culti.top.3, aes(rendi, culti)) +
  geom_point(colour = "black", size = 3, shape=1, stroke=1) +
  geom_point(aes(colour = gr.culti), shape=16, size = 3) + 
  #geom_vline(xintercept = 16.9, linetype="solid", 
  #color = "forestgreen", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Yield'~(Ton~x~ha^-1)))) + 
  scale_colour_brewer (name="Type of Crop", palette="Blues") + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=10), 
         axis.text = element_text(size=8), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())


png ("4. Cultivos en colombia.png",  width = 1400, height = 800, pointsize = 20)
grid.arrange(p13,p14,p15, 
             layout_matrix = rbind(c(1,2,3)))  #crear grafica con varias figuras
graphics.off()


## Correcion figura 
figura <- filter (prod.20.fh, culti=="COLIFLOR"|culti=="ZANAHORIA"|culti=="PUERRO"|
                    culti=="REPOLLO"|culti=="TOMATE"|culti=="REMOLACHA"|
                    culti=="PAPAYA"|culti=="CEBOLLA DE BULBO"|culti=="BROCOLI"|
                    culti=="FRESA"|culti=="POMELO"|culti=="LECHUGA"|
                    culti=="PINHA"|culti=="APIO"|culti=="MARACUYA"|
                    culti=="MELON"|culti=="BADEA"|culti=="LIMA"|
                    culti=="PATILLA"|culti=="CITRICOS")
                  

figura <- figura[complete.cases(figura),]

ggplot(figura, aes(x=reorder(culti, -rendi, mean), y=rendi)) +
  geom_boxplot(width=0.5, colour="black", aes(fill=gr.culti)) +
  scale_fill_brewer (name="Type of Crop", palette="Blues") + 
  scale_x_discrete (breaks = c("COLIFLOR",
                    "ZANAHORIA","PUERRO","REPOLLO","TOMATE","REMOLACHA","PAPAYA",
                    "CEBOLLA DE BULBO","BROCOLI","FRESA","POMELO","LECHUGA",
                    "PINHA","APIO","MARACUYA","MELON","BADEA","LIMA",
                    "PATILLA","CITRICOS"), labels = c("COLIFLOWER",
                    "CARROT","LEEK","CABBAGE","TOMATO","BEET","PAPAYA",
                    "ONION","BROCCOLI","STRAWBERRY","GRAPEFRUIT","LETTUCE",
                    "PINEAPPLE","CELERY","PASSION FRUIT","MELON","BADEA","LIME",
                    "WATERMELON","OTHER CITRUS")) +
  stat_summary(fun.y=mean, geom="point", col="Black", shape = 10, size=3) +
  theme_bw() + 
  ylab (expression(paste('Yield'~(Ton~x~ha^-1)))) + 
  xlab (expression(paste(''))) +
  theme (strip.text.x = element_text (face="bold", size=14, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12), 
         axis.text.x = element_text(angle = 90),
         legend.position = "right")

### Análisis Valle del Cauca ###
names (prod.20) # nombre de las columnas en la tabla prod.18
ungroup (prod.20)
valle.prod.20 <- subset (prod.20, depa =="VALLE DEL CAUCA")
valle.fruthort <- subset (valle.prod.20,  gr.culti =="FRUTALES" 
                          | gr.culti=="HORTALIZAS")

valle.fruthort <- valle.fruthort %>% group_by (muni,gr.culti,anho)
prod.muni.sum <-  summarise_each(valle.fruthort, funs(mean(.,na.rm = TRUE)))
ungroup(valle.fruthort)
valle.fruthort <- valle.fruthort %>% group_by (muni, gr.culti)
prod.valle.sum <-  summarise_each(valle.fruthort, funs(mean(.,na.rm = TRUE)))
ungroup (valle.fruthort)
valle.fruthort <- valle.fruthort %>% group_by (gr.culti)
valle.prom <- summarise_each(valle.fruthort, funs(mean(.,na.rm = TRUE)))

valle.frut <- subset (prod.valle.sum,  gr.culti =="FRUTALES")
valle.hort <- subset (prod.valle.sum,  gr.culti =="HORTALIZAS")



# Figura de puntos para el promedio de area sembrada de frutales por departamentos
valle.frut$muni <- factor(valle.frut$muni, 
                          levels=valle.frut$muni[order(valle.frut$ar.semb)]) ## organizar los datos deacuerdo al valor, de mayor a menor

p16 <- ggplot(valle.frut, aes(ar.semb, muni)) + 
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(colour = "dodgerblue", shape=16, size = 4) + 
  geom_vline(xintercept = 81.4, linetype="solid", 
             color = "dodgerblue", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Area sembrada'~(Hectareas)))) + 
  #scale_colour_manual (name="Cultivo", values=c("#00AFBB", "#FC4E07", "#00AFBB")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=12), 
         axis.text = element_text(size=10), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## promedio nacional frutales
valle.frut$muni <- factor(valle.frut$muni, 
                          levels=valle.frut$muni[order(valle.frut$produ)]) ## organizar los datos deacuerdo al valor, de mayor a menor

# Figura de puntos para el promedio produccion de frutales por departamentos
p17 <- ggplot(valle.frut, aes(produ, muni)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(colour = "dodgerblue", shape=16, size = 4) + 
  geom_vline(xintercept = 1426.4, linetype="solid", 
             color = "dodgerblue", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Produccion'~(Toneladas)))) + 
  #scale_colour_manual (name="Cultivo", values=c("#00AFBB", "#FC4E07", "#00AFBB")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=12), 
         axis.text = element_text(size=10), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## promedio nacional frutales
valle.frut$muni <- factor(valle.frut$muni, 
                          levels=valle.frut$muni[order(valle.frut$rendi)])## organizar los datos deacuerdo al valor, de mayor a menor

# Figura de puntos para el promedio de rendimiento de frutales por departamentos
p18 <- ggplot(valle.frut, aes(rendi, muni)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(colour = "dodgerblue", shape=16, size = 4) + 
  geom_vline(xintercept = 16.23, linetype="solid", 
             color = "dodgerblue", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) + 
  #scale_colour_manual (name="Cultivo", values=c("#00AFBB", "#FC4E07", "#00AFBB")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=12), 
         axis.text = element_text(size=10), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## promedio nacional area sembrada hortalizas
valle.hort$muni <- factor(valle.hort$muni, 
                          levels=valle.hort$muni[order(valle.hort$ar.semb)])## organizar los datos deacuerdo al valor, de mayor a menor

# Figura de puntos para el promedio de area sembrada de hortalizas por departamentos
p19 <- ggplot(valle.hort, aes(ar.semb, muni)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(colour = "orangered", shape=16, size = 4) + 
  geom_vline(xintercept = 15.3, linetype="solid", 
             color = "orangered", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Area sembrada'~(Hectareas)))) + 
  #scale_colour_manual (name="Cultivo", values=c("#00AFBB", "#FC4E07", "#00AFBB")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=12), 
         axis.text = element_text(size=10), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## promedio nacional produccion hortalizas
valle.hort$muni <- factor(valle.hort$muni, 
                          levels=valle.hort$muni[order(valle.hort$produ)]) ## organizar los datos deacuerdo al valor, de mayor a menor

# Figura de puntos para el promedio de produccion de hortalizas por departamentos
p20 <- ggplot(valle.hort, aes(produ, muni)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(colour = "orangered", shape=16, size = 4) + 
  geom_vline(xintercept = 261.8, linetype="solid", 
             color = "orangered", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Produccion'~(Toneladas)))) + 
  #scale_colour_manual (name="Cultivo", values=c("#00AFBB", "#FC4E07", "#00AFBB")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=12), 
         axis.text = element_text(size=10), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## promedio nacional rendimiento hortalizas
valle.hort$muni <- factor(valle.hort$muni, 
                          levels=valle.hort$muni[order(valle.hort$rendi)])## organizar los datos deacuerdo al valor, de mayor a menor

# Figura de puntos para el promedio de rendimiento de hortalizas por departamentos
p21 <- ggplot(valle.hort, aes(rendi, muni)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(colour = "orangered", shape=16, size = 4) + 
  geom_vline(xintercept = 16.9, linetype="solid", 
             color = "orangered", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) + 
  #scale_colour_manual (name="Cultivo", values=c("#00AFBB", "#FC4E07", "#00AFBB")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=12), 
         axis.text = element_text(size=10), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())




png ("5. Municipios valle frut y hort.png",  width = 1400, height = 800, pointsize = 20)
grid.arrange(p16,p17,p18,p19,p20,p21, 
             layout_matrix = rbind(c(1,2,3), c(4,5,6)))  #crear grafica con varias figuras
graphics.off()

## promedios producción por cultivo en el Valle del Cauca ##
ungroup (valle.fruthort)
names (valle.fruthort)
valle.fruthort <- valle.fruthort %>% group_by (culti, gr.culti)
valle.culti <- summarise_each(valle.fruthort, funs(mean(.,na.rm = TRUE)))


valle.culti$culti <- factor(valle.culti$culti, 
                            levels=valle.culti$culti[order(valle.culti$ar.semb)])## organizar los datos deacuerdo al valor, de mayor a menor

p22 <- ggplot(valle.culti, aes(ar.semb, culti)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(aes(colour = gr.culti), shape=16, size = 4) + 
  #geom_vline(xintercept = 16.9, linetype="solid", 
  #color = "forestgreen", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Area sembrada'~(Ha)))) + 
  scale_colour_manual (name="Tipo de cultivo", values=c("dodgerblue", "orangered")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=12), 
         axis.text = element_text(size=10), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

valle.culti$culti <- factor(valle.culti$culti, 
                            levels=valle.culti$culti[order(valle.culti$produ)])## organizar los datos deacuerdo al valor, de mayor a menor

p23 <- ggplot(valle.culti, aes(produ, culti)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(aes(colour = gr.culti), shape=16, size = 4) + 
  #geom_vline(xintercept = 16.9, linetype="solid", 
  #color = "forestgreen", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Produccion'~(Ton)))) + 
  scale_colour_manual (name="Tipo de cultivo", values=c("dodgerblue", "orangered")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=12), 
         axis.text = element_text(size=10), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())


valle.culti$culti <- factor(valle.culti$culti, 
                            levels=valle.culti$culti[order(valle.culti$rendi)])## organizar los datos deacuerdo al valor, de mayor a menor

p24 <- ggplot(valle.culti, aes(rendi, culti)) +
  geom_point(colour = "black", size = 4, shape=1, stroke=1) +
  geom_point(aes(colour = gr.culti), shape=16, size = 4) + 
  #geom_vline(xintercept = 16.9, linetype="solid", 
  #color = "forestgreen", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) + 
  scale_colour_manual (name="Tipo de cultivo", values=c("dodgerblue", "orangered")) + 
  theme_bw() + #facet_grid(. ~ variable, scales = "free", space = "free") +
  theme (axis.title = element_text (size=12), 
         axis.text = element_text(size=10), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())


png ("6. Mejores cultivos en el Valle.png",  width = 1400, height = 800, pointsize = 20)
grid.arrange(p22,p23,p24, 
             layout_matrix = rbind(c(1,2,3)))  #crear grafica con varias figuras
graphics.off()

write.table (valle.culti, "valle.culti.txt", sep="\t", dec=",")
write.table (nal.culti, "colombia.culti.txt", sep="\t", dec=",")

## Comparación colombia versus valle
## Creacion archivo
valle.comp <- read.delim("valle.culti.txt", dec=",")
colom.comp <- read.delim("colombia.culti.txt", dec=",")
comparados <- full_join (valle.comp, colom.comp, by="culti")
write.table (comparados, "comparacion colombia valle.txt", sep="\t", dec=",")

## Comparacion
comparar <- read.delim ("comparacion colombia valle.txt", dec=",")
library (ggalt)

ggplot(comparar, 
       aes(y = reorder(culti, rendi.v),
           x = rendi.c,
           xend = rendi.v)) +  
  geom_dumbbell(size = 1.5,
                size_x = 3, 
                size_xend = 3,
                colour = "grey90", 
                colour_x = "darkorange", 
                colour_xend = "forestgreen", dot_guide=TRUE, dot_guide_size=0.15) +
  ylab ("") + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) + 
  theme_bw() + scale_color_manual(values = c('Valle del Cauca' = ' forestgreen', 
                                             'Colombia' = 'darkorange')) +
  theme (axis.title = element_text (size=12), 
         axis.text = element_text(size=10), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.y=element_blank(),
         panel.grid.minor.y=element_blank())

ggsave ("7. comparacion rendimientos cultivos.png", width=15, height=10)

## Analisis de precios
library ("Hmisc")
library ("dplyr")
library ("reshape2")
library("ggplot2")
library ("RColorBrewer")
library("tidyr")
library("grid") # cargar paquete para crear grafica con varias figuras
library("gridExtra") 
setwd("~/Google Drive/Mi unidad/2. ITA/R files mac") ## abrir ubicacion de la carpeta de trabajo
precios <- read.delim ("precios.db.txt") # cargar archivo con datos
str (precios) # revisar estructura de los datos cargados
names (precios)
precios$precio <- as.numeric (precios$precio)
precios <- precios[complete.cases(precios),]
precios.fruthort <- subset (precios, gr.culti=="FRUTALES"|gr.culti=="HORTALIZAS")

precios.fruthort <- precios.fruthort %>% group_by (culti, gr.culti, anho)
precios.sum <- summarise_each(precios.fruthort, funs(mean(.,na.rm = TRUE)))

## Analisis de los precios
# boxplot (precios.sum$precio~precios.sum$culti) # Digrama de cajas para la variable rendimiento separada por grupo de cultivos

reorder_within <- function(x, by, within, fun = mean, sep = "___", ...) {
  new_x <- paste(x, within, sep = sep)
  stats::reorder(new_x, by, FUN = fun)
}


scale_x_reordered <- function(..., sep = "___") {
  reg <- paste0(sep, ".+$")
  ggplot2::scale_x_discrete(labels = function(x) gsub(reg, "", x), ...)
}

names (precios.sum)
levels (precios.sum$gr.culti) <- c("", "FRUITS", "PULSES", "VEGETABLES", "TUBERS", "TUBERS")
levels (precios.sum$culti) <- c("","Avocado","Squash",                    
"Garlic", "Celery","Arracacha",                  
 "Rice","Green peas","Imported green peas",
 "Banana","Onion","Bunching onion",              
 "Corn","Coconut","Dry beans",                
 "Green beans","Chickpea","Sweet Granadilla",                 
 "Guava","String bean","Lettuce",            
 "Lentils","Lemon","Thaiti lemon",               
 "Naranjilla","Yellow corn","White corn",       
 "Mandarine","Mango","Red apple",     
 "Royal apple","Green apple","Passion fruit",                   
 "Melon","Blackberry","Orange",           
 "Yellow potato","Black potato","Papaya",             
 "Cucumber","Pear","Sweet pepper",                   
 "Pineapple","Plantain","Green plantain",       
 "Beet","Cabbage","Tomato",                     
 "Isabela grape","Grape","Cassava",                       
 "Carrot")

ggplot(precios.sum, aes(x=reorder_within(culti, precio, gr.culti, mean), y=precio)) +
  geom_boxplot(colour="black", fill="Seagreen2") +
  scale_x_reordered() +
  stat_summary(fun.y=mean, geom="point", col="Black", shape = 10, size=3) +
  theme_bw() + facet_grid(. ~ gr.culti, scales = "free", space = "free") +
  ylab ("Price in COP per kg product") + xlab (expression(paste('Crop'))) +
  theme (strip.text.x = element_text (face="bold", size=14, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12), 
         axis.text.x = element_text(angle = 90),
         legend.position = "none")

ggsave ("8. Promedio de Precios cultivos.png", width=20, height=10)

nb.cols <- 39
mycolors <- colorRampPalette(brewer.pal(9, "Set1"))(nb.cols)

ggplot(precios.sum, aes(x=anho, y=precio, colour=culti, label=culti)) +
  geom_line (linetype=3, size=0.8) +
  geom_point(size=3, stroke=1) +
  geom_text(size=5, check_overlap = TRUE, colour="black", alpha=0.9) +
  theme_bw() + facet_grid(. ~ gr.culti, scales = "free", space = "free") +
  scale_colour_manual(name="Cultivo", values=mycolors) + 
  ylab ("Precios por kg") + xlab (expression(paste('Anho'))) +
  theme (strip.text.x = element_text (face="bold", size=14, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=15), 
         axis.text = element_text(size=14), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(), 
         legend.position="none")

ggsave ("9. variacion precios cultivos por a?o.png", width=20, height=10)
graphics.off()



## Precios en Cali
ungroup (precios.fruthort)

precios.fruthort <- precios.fruthort %>% group_by (culti, gr.culti, muni)
precios.muni <- summarise_each(precios.fruthort, funs(mean(.,na.rm = TRUE)))
names(precios.muni)

## Barranquilla
precios.barran <- subset (precios.muni, muni=="BARRANQUILLA")
precios.barran$culti <- factor(precios.barran$culti, 
                               levels=precios.barran$culti[order(precios.barran$precio)])## organizar los datos deacuerdo al valor, de mayor a menor

p27 <- ggplot(precios.barran, aes(precio, culti)) +
  geom_point(colour = "black", size = 2, shape=1, stroke=1) +
  geom_point(aes(colour = gr.culti), shape=16, size = 2) + 
  #geom_vline(xintercept = 16.9, linetype="solid", 
  #color = "forestgreen", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Precio'~(pesos~x~kg^-1)))) + 
  scale_colour_manual (name="Tipo de cultivo", values=c("dodgerblue", "orangered")) + 
  theme_bw() + facet_grid(. ~ muni, scales = "free", space = "free") +
  theme (legend.position="none", axis.title = element_text (size=10), 
         axis.text = element_text(size=7), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## Bogota
precios.bogo <- subset (precios.muni, muni=="BOGOTA")
precios.bogo$culti <- factor(precios.bogo$culti, 
                             levels=precios.bogo$culti[order(precios.bogo$precio)])## organizar los datos deacuerdo al valor, de mayor a menor

p28 <- ggplot(precios.bogo, aes(precio, culti)) +
  geom_point(colour = "black", size = 2, shape=1, stroke=1) +
  geom_point(aes(colour = gr.culti), shape=16, size = 2) + 
  #geom_vline(xintercept = 16.9, linetype="solid", 
  #color = "forestgreen", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Precio'~(pesos~x~kg^-1)))) + 
  scale_colour_manual (name="Tipo de cultivo", values=c("dodgerblue", "orangered")) + 
  theme_bw() + facet_grid(. ~ muni, scales = "free", space = "free") +
  theme (legend.position="none", axis.title = element_text (size=10), 
         axis.text = element_text(size=7), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## Bucaramanga
precios.buca <- subset (precios.muni, muni=="BUCARAMANGA")
precios.buca$culti <- factor(precios.buca$culti, 
                             levels=precios.buca$culti[order(precios.buca$precio)])## organizar los datos deacuerdo al valor, de mayor a menor

p29 <- ggplot(precios.buca, aes(precio, culti)) +
  geom_point(colour = "black", size = 2, shape=1, stroke=1) +
  geom_point(aes(colour = gr.culti), shape=16, size = 2) + 
  #geom_vline(xintercept = 16.9, linetype="solid", 
  #color = "forestgreen", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Precio'~(pesos~x~kg^-1)))) + 
  scale_colour_manual (name="Tipo de cultivo", values=c("dodgerblue", "orangered")) + 
  theme_bw() + facet_grid(. ~ muni, scales = "free", space = "free") +
  theme (legend.position="none", axis.title = element_text (size=10), 
         axis.text = element_text(size=7), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## Cali
precios.cali <- subset (precios.muni, muni=="CALI")
precios.cali$culti <- factor(precios.cali$culti, 
                             levels=precios.cali$culti[order(precios.cali$precio)])## organizar los datos deacuerdo al valor, de mayor a menor

p30 <- ggplot(precios.cali, aes(precio, culti)) +
  geom_point(colour = "black", size = 2, shape=1, stroke=1) +
  geom_point(aes(colour = gr.culti), shape=16, size = 2) + 
  #geom_vline(xintercept = 16.9, linetype="solid", 
  #color = "forestgreen", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Precio'~(pesos~x~kg^-1)))) + 
  scale_colour_manual (name="Tipo de cultivo", values=c("dodgerblue", "orangered")) + 
  theme_bw() + facet_grid(. ~ muni, scales = "free", space = "free") +
  theme (legend.position="none", axis.title = element_text (size=10), 
         axis.text = element_text(size=7), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## Cartagena
precios.carta <- subset (precios.muni, muni=="CARTAGENA")
precios.carta$culti <- factor(precios.carta$culti, 
                              levels=precios.carta$culti[order(precios.carta$precio)])## organizar los datos deacuerdo al valor, de mayor a menor

p31 <- ggplot(precios.carta, aes(precio, culti)) +
  geom_point(colour = "black", size = 2, shape=1, stroke=1) +
  geom_point(aes(colour = gr.culti), shape=16, size = 2) + 
  #geom_vline(xintercept = 16.9, linetype="solid", 
  #color = "forestgreen", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Precio'~(pesos~x~kg^-1)))) + 
  scale_colour_manual (name="Tipo de cultivo", values=c("dodgerblue", "orangered")) + 
  theme_bw() + facet_grid(. ~ muni, scales = "free", space = "free") +
  theme (legend.position="none", axis.title = element_text (size=10), 
         axis.text = element_text(size=7), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## Cucuta
precios.cucu <- subset (precios.muni, muni=="CUCUTA")
precios.cucu$culti <- factor(precios.cucu$culti, 
                             levels=precios.cucu$culti[order(precios.cucu$precio)])## organizar los datos deacuerdo al valor, de mayor a menor

p32 <- ggplot(precios.cucu, aes(precio, culti)) +
  geom_point(colour = "black", size = 2, shape=1, stroke=1) +
  geom_point(aes(colour = gr.culti), shape=16, size = 2) + 
  #geom_vline(xintercept = 16.9, linetype="solid", 
  #color = "forestgreen", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Precio'~(pesos~x~kg^-1)))) + 
  scale_colour_manual (name="Tipo de cultivo", values=c("dodgerblue", "orangered")) + 
  theme_bw() + facet_grid(. ~ muni, scales = "free", space = "free") +
  theme (legend.position="none", axis.title = element_text (size=10), 
         axis.text = element_text(size=7), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## Medellin
precios.mede <- subset (precios.muni, muni=="MEDELLIN")
precios.mede$culti <- factor(precios.mede$culti, 
                             levels=precios.mede$culti[order(precios.mede$precio)])## organizar los datos deacuerdo al valor, de mayor a menor

p33 <- ggplot(precios.mede, aes(precio, culti)) +
  geom_point(colour = "black", size = 2, shape=1, stroke=1) +
  geom_point(aes(colour = gr.culti), shape=16, size = 2) + 
  #geom_vline(xintercept = 16.9, linetype="solid", 
  #color = "forestgreen", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Precio'~(pesos~x~kg^-1)))) + 
  scale_colour_manual (name="Tipo de cultivo", values=c("dodgerblue", "orangered")) + 
  theme_bw() + facet_grid(. ~ muni, scales = "free", space = "free") +
  theme (legend.position="none", axis.title = element_text (size=10), 
         axis.text = element_text(size=7), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

## Pereira
precios.pere <- subset (precios.muni, muni=="PEREIRA")
precios.pere$culti <- factor(precios.pere$culti, 
                             levels=precios.pere$culti[order(precios.pere$precio)])## organizar los datos deacuerdo al valor, de mayor a menor

p34 <- ggplot(precios.pere, aes(precio, culti)) +
  geom_point(colour = "black", size = 2, shape=1, stroke=1) +
  geom_point(aes(colour = gr.culti), shape=16, size = 2) + 
  #geom_vline(xintercept = 16.9, linetype="solid", 
  #color = "forestgreen", size=0.2) +
  #geom_vline(xintercept = 11.55, linetype="solid", 
  #color = "#FC4E07", size=0.2) +
  ylab ("") + xlab (expression(paste('Precio'~(pesos~x~kg^-1)))) + 
  scale_colour_manual (name="Tipo de cultivo", values=c("dodgerblue", "orangered")) + 
  theme_bw() + facet_grid(. ~ muni, scales = "free", space = "free") +
  theme (legend.position="none", axis.title = element_text (size=10), 
         axis.text = element_text(size=7), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

png ("10. Precios ciudades.png",  width = 1400, height = 800, pointsize = 20)
grid.arrange(p27,p28,p29,p30,p31,p32,p33,p34,
             layout_matrix = rbind(c(1,2,3,4),  c(5,6,7,8)))  #crear grafica con varias figuras
graphics.off()


# Corrrelacion precios vs produccion
cor.prod <- subset (nal.fruthort, depa=="ATLANTICO"|depa=="CUNDINAMARCA"|depa=="SANTANDER"
                    |depa=="VALLE DEL CAUCA"|depa=="BOLIVAR"|depa=="NORTE DE SANTANDER"
                    |depa=="ANTIOQUIA" |depa=="RISARALDA")

cor.prod <- subset (cor.prod, anho=="2015"|anho=="2016"|anho=="2017"
                    |anho=="2018")

cor.prod <- subset (cor.prod, culti=="AGUACATE"|culti=="AHUYAMA"|culti=="AJO"
                    |culti=="APIO"|culti=="CEBOLLA DE BULBO"|culti=="CEBOLLA DE RAMA"|
                      culti=="LECHUGA"|culti=="PEPINO COHOMBRO"|culti=="PIMENTON"
                    |culti=="REPOLLO"|culti=="TOMATE"|culti=="ZANAHORIA"|
                      culti=="BANANO"|culti=="COCO"|culti=="GRANADILLA"|
                      culti=="GUAYABA" |culti=="LIMON"|culti=="LULO"|culti=="MANDARINA"
                    |culti=="APIO"|culti=="CEBOLLA DE BULBO"|culti=="CEBOLLA DE RAMA"|
                      culti=="MANGO"|culti=="MANZANA"|culti=="MARACUYA"
                    |culti=="MELON"|culti=="MORA"|culti=="NARANJA"|
                      culti=="PAPAYA"|culti=="PINHA")

ungroup (cor.prod)
cor.prod <- cor.prod %>% group_by (culti, depa, anho)
cor.prod.sum <- summarise_each(cor.prod, funs(mean(.,na.rm = TRUE)))

#write.table (cor.prod.sum, "datos correlaciones produccion.txt", sep="\t", dec=",")  



precios.fruthort <- precios.fruthort %>% group_by (culti, muni, anho)
cor.precios.sum <- summarise_each(precios.fruthort, funs(mean(.,na.rm = TRUE)))
#write.table (cor.precios.sum, "datos correlaciones precios.txt", sep="\t", dec=",")

## Analisis de insumos
library ("Hmisc")
library ("dplyr")
library ("reshape2")
library("ggplot2")
library ("RColorBrewer")
library("tidyr")
library("grid") # cargar paquete para crear grafica con varias figuras
library("gridExtra")
setwd("~/Library/CloudStorage/OneDrive-Personal/Documentos/Sebastian/Academia/4. Data science/R projects")
insumos <- read.delim ("insumos.txt", dec=",")
str (insumos)
names (insumos)

source ("~/Google Drive/Mi unidad/1. Sebastian PhD/R files/Function outliers.r") ## outliers function
names(insumos)
preciosin.o <- as.data.frame(remove_outliers (insumos$precio.in))


insumos.f <- select (insumos, tipo,depa,anho)
insumos.woo <- bind_cols (insumos.f, preciosin.o)
insumos.matrix <- na.exclude (insumos.woo)
names (insumos.matrix)


names (insumos.matrix) [4] <- paste ("precios.in")


reorder_within <- function(x, by, within, fun = mean, sep = "___", ...) {
  new_x <- paste(x, within, sep = sep)
  stats::reorder(new_x, by, FUN = fun)
}


scale_x_reordered <- function(..., sep = "___") {
  reg <- paste0(sep, ".+$")
  ggplot2::scale_x_discrete(labels = function(x) gsub(reg, "", x), ...)
}

library ("scales")

levels (insumos.matrix$tipo)
levels (insumos.matrix$tipo) <- c("FERTILIZERS", "FUNGICIDES", "HERBICIDES", "INSECTICIDES")

ggplot(insumos.matrix, aes(x=reorder_within(depa, precios.in, tipo, mean), y=precios.in)) +
  geom_boxplot(colour="black", fill="seagreen2") +
  scale_x_reordered() +
  scale_y_continuous(labels=comma) +
  stat_summary(fun.y=mean, geom="point", col="Black", shape = 10, size=3) +
  theme_bw() + facet_grid(. ~ tipo, scales = "free", space = "free") +
  ylab ("Prices in COP") + xlab (expression(paste('Locations'))) +
  theme (strip.text.x = element_text (face="bold", size=14, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12), 
         axis.text.x = element_text(angle = 90),
         legend.position = "none")

insumos.depa<- subset (insumos, depa=="Atlantico"|depa=="Cundinamarca"|
                         depa=="Santander" |depa=="Valle del Cauca"|
                         depa=="Bolivar"|depa=="Norte de Santander"
                       |depa=="Antioquia" |depa=="Risaralda")

insumos.depa <- subset (insumos.depa, anho=="2015"|anho=="2016"|anho=="2017"
                        |anho=="2018")

names (insumos.depa)
ungroup (insumos.depa)
insumos.depa <- insumos.depa %>% group_by (produ, depa, anho)
insumos.prod.sum <- summarise_each(insumos.depa, funs(mean(.,na.rm = TRUE)))

ungroup (insumos.depa)
insumos.depa <- insumos.depa %>% group_by (tipo, depa, anho)
insumos.tipo.sum <- summarise_each(insumos.depa, funs(mean(.,na.rm = TRUE)))

# write.table (insumos.tipo.sum, "datos correlaciones insumos por tipo.txt", 
# sep="\t", dec=",")  


###############################################
## Correlaciones precios valor insumos produ ##
###############################################
library ("Hmisc")
library ("dplyr")
library ("reshape2")
library("ggplot2")
library ("RColorBrewer")
library("tidyr")
library("grid") # cargar paquete para crear grafica con varias figuras
library("gridExtra")
getwd()
setwd("~/Google Drive/Mi unidad/2. ITA/R files mac") ## abrir ubicacion de la carpeta de trabajo
cor.prod.pre <- read.delim ("corr.precios.insumos.produccion.txt", dec=",")
str (cor.prod.pre)
cor.prod.pre <- cor.prod.pre [complete.cases(cor.prod.pre),]
names (cor.prod.pre)
boxplot (cor.prod.pre$rendi)
boxplot (cor.prod.pre$ar.semb)
boxplot (cor.prod.pre$ar.cose)
boxplot (cor.prod.pre$produ)
boxplot (cor.prod.pre$precio.com)
boxplot (cor.prod.pre$precio.fer)
boxplot (cor.prod.pre$precio.fun)
boxplot (cor.prod.pre$precio.her)
boxplot (cor.prod.pre$precio.ins)

## Eliminación de outliers en los datos
source ("~/Google Drive/Mi unidad/1. Sebastian PhD/R files/Function outliers.r") ## outliers function
names(cor.prod.pre)
ar.semb.o <- as.data.frame(remove_outliers (cor.prod.pre$ar.semb))
ar.cose.o <- as.data.frame(remove_outliers (cor.prod.pre$ar.cose))
produ.o <- as.data.frame(remove_outliers (cor.prod.pre$produ))
rendi.o <- as.data.frame(remove_outliers (cor.prod.pre$rendi))
precio.com.o <- as.data.frame(remove_outliers (cor.prod.pre$precio.com))
precio.fer.o <- as.data.frame(remove_outliers (cor.prod.pre$precio.fer))
precio.fun.o <- as.data.frame(remove_outliers (cor.prod.pre$precio.fun))
precio.her.o <- as.data.frame(remove_outliers (cor.prod.pre$precio.her))
precio.ins.o <- as.data.frame(remove_outliers (cor.prod.pre$precio.ins))

cor.prod.pre.f <- select (cor.prod.pre, culti,depa,anho)
cor.prod.pre.woo <- bind_cols (cor.prod.pre.f, ar.semb.o, 
                               ar.cose.o, produ.o, rendi.o, precio.com.o, 
                               precio.fer.o, precio.fun.o, precio.her.o, 
                               precio.ins.o)
corr.matrix <- na.exclude (cor.prod.pre.woo)
names (corr.matrix)


names (corr.matrix) [4] <- paste ("sembrada")
names (corr.matrix) [5] <- paste ("cosechada")
names (corr.matrix) [6] <- paste ("produccion")
names (corr.matrix) [7] <- paste ("rendimiento")
names (corr.matrix) [8] <- paste ("precio.com")
names (corr.matrix) [9] <- paste ("precio.fer")
names (corr.matrix) [10] <- paste ("precio.fun")
names (corr.matrix) [11] <- paste ("precio.her")
names (corr.matrix) [12] <- paste ("precio.ins")
names (corr.matrix)

boxplot (corr.matrix$sembrada)
boxplot (corr.matrix$cosechada)
boxplot (corr.matrix$produccion)
boxplot (corr.matrix$rendimiento)
boxplot (corr.matrix$precio.com)
boxplot (corr.matrix$precio.fer)
boxplot (corr.matrix$precio.fun)
boxplot (corr.matrix$precio.ins)

# correolograma
pairs.cor <- function (x,y,smooth=TRUE, digits=2,  ...)
{
  panel.cor <- function(x, y, ...)
  {
    usr <- par("usr"); on.exit(par(usr))
    par(usr = c(0, 1, 0, 1))
    r.obj = cor.test(x, y,use="pairwise",...)
    r = as.numeric(r.obj$estimate)
    p = r.obj$p.value
    mystars <- ifelse(p < .05, "* ", " ")
    txt <- format(c(r, 0.123456789), digits=digits)[1]
    txt <- paste(txt, mystars, sep="")
    text(0.5, 0.5, txt)
  }
  panel.hist <- function(x)
  {
    usr <- par("usr"); on.exit(par(usr))
    par(usr = c(usr[1:2], 0, 1.5) )
    h <- hist(x, plot = FALSE)
    breaks <- h$breaks; nB <- length(breaks)
    y <- h$counts; y <- y/max(y)
    rect(breaks[-nB], 0, breaks[-1], y, col="cyan")
  }
  pairs(x,diag.panel=panel.hist,lower.panel=panel.cor,upper.panel=panel.smooth, ...)
} 

names (corr.matrix)
pairs.cor(corr.matrix[,4:12])

ungroup(corr.matrix)
corr.matrix <- corr.matrix %>% group_by (depa, culti)
corr.matrix.sum <- summarise_each(corr.matrix, funs(mean(.,na.rm = TRUE)))
pairs.cor(corr.matrix.sum[,4:12])


# area sembrada - area cosechada
ggplot (corr.matrix.sum, aes (x=sembrada, y=cosechada, label=culti)) + 
  geom_point (aes (colour=depa), size=2, alpha=1) + theme_bw() +
  geom_text(size=4, check_overlap = TRUE, colour="black", alpha=1) +
  scale_colour_brewer (name="Cultivo", palette="Pastel1") + 
  scale_shape (name="Treatment", breaks=c("HP", "LP"), 
    labels=c("High P", "Low P"), solid=T)  + 
  xlab (expression (paste ('Area sembrada'~(ha)))) + 
  ylab (expression (paste ('Produccion'~(Ton)))) +
  facet_grid(. ~ depa, scales = "free", space = "free") +
  geom_smooth(method=lm, se=T, linetype= "dotted", size = 0.5, alpha=0.3) +
  theme (legend.position="none", axis.title = element_text (size=12), 
         axis.text = element_text(size=11), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())

# area sembrada - produccion
names (corr.matrix)
ggplot (corr.matrix.sum, aes (x=sembrada, y=produccion, label=culti)) + 
  geom_point (aes (colour=depa), size=4, alpha=1) + theme_bw() +
  geom_text(size=4, check_overlap = TRUE, colour="black", alpha=1) +
  scale_colour_brewer (name="Cultivo", palette="Pastel1") + 
  scale_shape (name="Treatment", breaks=c("HP", "LP")) + 
             #  labels=c("High P", "Low P"), solid=T)  + 
  xlab (expression (paste ('Area sembrada'~(ha)))) + 
  ylab (expression (paste ('Produccion'~(Ton)))) +
  facet_grid(. ~ depa, scales = "free", space = "free") +
  geom_smooth(method=lm, se=T, linetype= "dotted", size = 0.5, alpha=0.3) +
  theme (legend.position="none", axis.title = element_text (size=12), 
         axis.text = element_text(size=11), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())
ggsave ("12. cor area sembrada produccion.png", width=15, height=10)

# area sembrada - rendimiento
ggplot (corr.matrix.sum, aes (x=sembrada, y=rendimiento, label=culti)) + 
  geom_point (aes (colour=depa), size=4, alpha=1) + theme_bw() +
  geom_text(size=4, check_overlap = TRUE, colour="black", alpha=1) +
  scale_colour_brewer (name="Cultivo", palette="Pastel1") + 
  scale_shape (name="Treatment", breaks=c("HP", "LP"), 
               labels=c("High P", "Low P"), solid=T)  + 
  xlab (expression (paste ('Area sembrada'~(ha)))) + 
  ylab (expression (paste ('Rendimiento'~(Ton~x~ha^-1)))) + 
  facet_grid(. ~ depa, scales = "free", space = "free") +
  geom_smooth(method=lm, se=F, linetype= "dotted", size = 0.5, alpha=0.3) +
  theme (legend.position="none", axis.title = element_text (size=12), 
         axis.text = element_text(size=11), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())
ggsave ("13. cor area sembrada rendimiento.png", width=15, height=10)

# area sembrada - herbecidas
ggplot (corr.matrix.sum, aes (y=sembrada, x=precio.her, label=culti)) + 
  geom_point (aes (colour=depa), size=4, alpha=1) + theme_bw() +
  geom_text(size=4, check_overlap = T, colour="black", alpha=1) +
  scale_colour_brewer (name="Departamento", palette="Pastel1") + 
  scale_shape (name="Treatment", breaks=c("HP", "LP"), 
               labels=c("High P", "Low P"), solid=T)  + 
  ylab (expression (paste ('Area sembrada'~(ha)))) + 
  xlab (expression (paste ('Precio promedio herbicidas'~('$')))) + 
  #facet_grid(. ~ depa, scales = "free", space = "free") +
  geom_smooth(method=lm, se=T, linetype= "dotted", size = 0.5, alpha=0.3) +
  theme (legend.position="right", axis.title = element_text (size=12), 
         axis.text = element_text(size=11), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())
ggsave ("14. cor herbicidas area sembrada.png", width=15, height=10)

# area sembrada - insecticidas
ggplot (corr.matrix, aes (y=sembrada, x=precio.ins, label=culti)) + 
  geom_point (aes (colour=depa), size=4, alpha=1) + theme_bw() +
  geom_text(size=4, check_overlap = T, colour="black", alpha=1) +
  scale_colour_brewer (name="Departamentos", palette="Pastel1") + 
  scale_shape (name="Treatment", breaks=c("HP", "LP"), 
               labels=c("High P", "Low P"), solid=T)  + 
  ylab (expression (paste ('Area sembrada'~(ha)))) + 
  xlab (expression (paste ('Precio promedio insecticidas'~('$')))) + 
  #facet_grid(. ~ depa, scales = "free", space = "free") +
  geom_smooth(method=lm, se=T, linetype= "dotted", size = 0.5, alpha=0.3) +
  theme (legend.position="right", axis.title = element_text (size=12), 
         axis.text = element_text(size=11), 
         axis.text.x = element_text(angle = 0),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank())
ggsave ("15. cor insecticidas area sembrada.png", width=15, height=10)

## PCA + cluster 
library(factoextra)
names (corr.matrix.sum)
pca.agro <- prcomp (~ sembrada+cosechada+produccion+rendimiento+
                      precio.com+precio.fer+precio.fun+precio.her+precio.ins,  
                    data = corr.matrix.sum, scale = T)

biplot(pca.agro, cex=0.9)
abline(v=0, h=0)
summary(pca.agro)
eizscore.pca.agro <- pca.agro$sd^2
eizscore.pca.agro
pcscores.pca.agro = as.data.frame(pca.agro$x)
eiged <- as.data.frame(pca.agro$rotation)



library (FactoMineR)
names (corr.matrix.sum) [4] <- paste ("CAR")
names (corr.matrix.sum) [5] <- paste ("HAR")
names (corr.matrix.sum) [6] <- paste ("PRO")
names (corr.matrix.sum) [7] <- paste ("YIE")
names (corr.matrix.sum) [8] <- paste ("CPR")
names (corr.matrix.sum) [9] <- paste ("FRP")
names (corr.matrix.sum) [10] <- paste ("FUP")
names (corr.matrix.sum) [11] <- paste ("HEP")
names (corr.matrix.sum) [12] <- paste ("INP")
names (corr.matrix.sum)

pcahp <- PCA (corr.matrix.sum[,4:12], graph=F)


fviz_pca_biplot(pcahp, 
                geom.ind = "point",
                pointshape = 20,
                col.ind = corr.matrix.sum$depa, 
                palette = "Dark2",
                addEllipses = T, label = "var",
                ellipse.type = "confidence",
                gradient.cols = "Dark2",
                col.var = "grey20", repel = T,
                legend.title = "Locations",
                ggtheme = theme_minimal(), 
                axes.linetype = "dotted", xlim=c(-6,6),
                ylim=c(-3, 3)
                )

summary.PCA (pcahp)

## PCA selected crops
names (corr.matrix.sum)
corr.matrix.sum$culti <- as.factor (corr.matrix.sum$culti) 
levels(corr.matrix.sum$culti)

selected.crop <- filter (corr.matrix.sum, culti=="CEBOLLA DE BULBO"|
                        culti=="LECHUGA"|culti=="LIMON"|culti=="MARACUYA"|
                        culti=="MELON"|culti=="PAPAYA"|culti=="PINHA"|
                        culti=="REPOLLO"|culti=="TOMATE"|culti=="ZANAHORIA")

pca.selected <- PCA (selected.crop[,4:12], graph=F)

fviz_pca_biplot(pca.selected, 
                geom.ind = "point",
                pointshape = 20,
                col.ind = selected.crop$culti, 
                palette = "Paired",
                addEllipses = T, label = "var",
                ellipse.type = "confidence",
                gradient.cols = "Paired",
                col.var = "grey20", repel = T,
                legend.title = "Crops",
                ggtheme = theme_minimal(), 
                axes.linetype = "dotted", xlim=c(-6,6),
                ylim=c(-3, 3)
)

####################################
### Aplicacion de modelos lineales mixtos para determinar la estabilidad en el rendimiento ###
#########
library ("Hmisc")
library ("dplyr")
library ("reshape2")
library("ggplot2")
library ("RColorBrewer")
library("tidyr")
library("grid") # cargar paquete para crear grafica con varias figuras
library("gridExtra") # cargar paquete para crear grafica con varias figuras
library ("viridis")
library ("lme4")
#library("MASS")
library("car")
library("MuMIn")
library("report")
library ("sjPlot")

getwd()
setwd("~/Google Drive/Mi unidad/2. ITA/R files mac")
prod.20 <- read.delim ("prod.07-20.txt", dec=",")
str (prod.20) # revisar estructura de los datos cargados
names (prod.20) # revisar el nombre de las columnas de la tabla
prod.20$cod.depa <- as.factor (prod.20$cod.depa) # asignar categoria de factor a las columna
prod.20$depa <- as.factor (prod.20$depa) # asignar categoria de factor a las columna
prod.20$cod.muni <- as.factor (prod.20$cod.muni) # asignar categoria de factor a las columna
prod.20$muni <- as.factor (prod.20$muni) # asignar categoria de factor a las columna
prod.20$gr.culti <- as.factor (prod.20$gr.culti) # asignar categoria de factor a las columna
prod.20$subgr.culti <- as.factor (prod.20$subgr.culti) # asignar categoria de factor a las columna
prod.20$culti <- as.factor (prod.20$culti) # asignar categoria de factor a las columna
#prod.20$anho <- as.factor (prod.20$anho) # No se cambia la categoria de la columna año para realizar las figuras 
prod.20$period <- as.factor (prod.20$period) # asignar categoria de factor a las columna
prod.20$tipo.culti <- as.factor (prod.20$tipo.culti) # asignar categoria de factor a las columna

prod.20$ar.semb <- as.numeric (prod.20$ar.semb) # asignar categoria de variable numerica a las columna
prod.20$ar.cose <- as.numeric (prod.20$ar.cose) # asignar categoria de variable numerica a las columna
prod.20$produ <- as.numeric (prod.20$produ) # asignar categoria de variable numerica a las columna
prod.20$rendi <- as.numeric (prod.20$rendi) # asignar categoria de variable numerica a las columna

str (prod.20) 

## ANALISIS DE FRUTALES Y HORTALIZAS PARA PUBLICACION
## Eliminación de outliers base de datos productividad objeto prod.20

prod.20.fh <- subset (prod.20, gr.culti =="FRUTALES"|gr.culti=="HORTALIZAS") 
names(prod.20.fh)
hist (prod.20.fh$rendi)
boxplot (prod.20.fh$rendi)

source ("~/Google Drive/Mi unidad/1. Sebastian PhD/R files/Function outliers.r") ## outliers function
names(prod.20.fh)
ar.semb.o <- as.data.frame(remove_outliers (prod.20.fh$ar.semb))
ar.cose.o <- as.data.frame(remove_outliers (prod.20.fh$ar.cose))
produ.o <- as.data.frame(remove_outliers (prod.20.fh$produ))
rendi.o <- as.data.frame(remove_outliers (prod.20.fh$rendi))

prod.20.f <- select (prod.20.fh, depa, muni, gr.culti, culti,anho)
prod.20.fh <- bind_cols (prod.20.f, ar.semb.o, 
                         ar.cose.o, produ.o, rendi.o)

names (prod.20.fh)


names (prod.20.fh) [6] <- paste ("ar.semb")
names (prod.20.fh) [7] <- paste ("ar.cose")
names (prod.20.fh) [8] <- paste ("produ")
names (prod.20.fh) [9] <- paste ("rendi")

hist (prod.20.fh$rendi)
boxplot (prod.20.fh$rendi)
ggplot (prod.20.fh, aes(rendi)) + 
  geom_histogram(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))

#Normalizacion de los datos - no needed in the analysis
#zscoreprod.20 <- as.data.frame (scale(prod.20.fh[,c(-1:-9,-14)]), center=T, 
                               # scale=T)
#prod.20.f <- select (prod.20.fh, depa, muni, gr.culti, culti, anho)
#prod.20.fh.new <- bind_cols (prod.20.f, zscoreprod.20)
#qqp(prod.20.fh.new$rendi, "norm")


## subset by crop y aplicacion del modelo: año:fixed - depa:random
# coliflor pocas observaciones
coliflor <- subset (prod.20.fh, culti =="COLIFLOR") 
coliflor$anho <- coliflor$anho - mean(coliflor$anho)
ggplot (coliflor, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
qqp(coliflor$rendi, "norm")
lm.coliflor <- lmer(rendi ~ anho + (1|depa), REML=T,data = coliflor)
summary(lm.coliflor)
ggplot(coliflor, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")


# zanahoria
zanahoria <- subset (prod.20.fh, culti =="ZANAHORIA")
zanahoria$anho <- zanahoria$anho - mean(zanahoria$anho)
ggplot (zanahoria, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.zanahoria <- lmer(rendi ~ anho + (1|depa),REML=T, data = zanahoria)
summary(lm.zanahoria)
Anova(lm.zanahoria)
r.squaredGLMM(lm.zanahoria)
plot(lm.zanahoria)
tab_model(lm.zanahoria)
report(lm.zanahoria)
ggplot(zanahoria, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")


# puerro (pocas observaciones)
puerro <- subset (prod.20.fh, culti =="PUERRO")
puerro$anho <- puerro$anho - mean(puerro$anho)
ggplot (puerro, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.puerro <- lmer(rendi ~ anho + (1|depa),REML=T, data = puerro)
summary(lm.puerro)
Anova(lm.puerro)
r.squaredGLMM(lm.puerro)
plot(lm.puerro)
ggplot(puerro, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# repollo
repollo <- subset (prod.20.fh, culti =="REPOLLO")
repollo$anho <- repollo$anho - mean(repollo$anho)
ggplot (repollo, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.repollo <- lmer(rendi ~ anho + (1|depa),REML=T, data = repollo)
summary(lm.repollo)
Anova(lm.repollo)
r.squaredGLMM(lm.repollo)
plot(lm.repollo)
tab_model(lm.repollo)
report(lm.repollo)
ggplot(repollo, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# tomate
tomate <- subset (prod.20.fh, culti =="TOMATE")
tomate$anho <- tomate$anho - mean(tomate$anho)
ggplot (tomate, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.tomate <- lmer(rendi ~ anho + (1|depa),REML=T, data = tomate)
summary(lm.tomate)
Anova(lm.tomate)
r.squaredGLMM(lm.tomate)
plot(lm.tomate)
tab_model(lm.tomate)
report(lm.tomate)
ggplot(tomate, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# remolacha pocas observaciones
remolacha <- subset (prod.20.fh, culti =="REMOLACHA")
remolacha$anho <- remolacha$anho - mean(remolacha$anho)
ggplot (remolacha, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.remolacha <- lmer(rendi ~ anho + (1|depa),REML=T, data = remolacha)
summary(lm.remolacha)
Anova(lm.remolacha)
plot(lm.remolacha)
ggplot(remolacha, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# cebolla
cebolla <- subset (prod.20.fh, culti =="CEBOLLA DE BULBO")
cebolla$anho <- cebolla$anho - mean(cebolla$anho)
ggplot (cebolla, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.cebolla <- lmer(rendi ~ anho + (1|depa),REML=T, data = cebolla)
summary(lm.cebolla)
Anova(lm.cebolla)
r.squaredGLMM(lm.cebolla)
plot(lm.cebolla)
tab_model(lm.cebolla)
report(lm.cebolla)
ggplot(cebolla, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# brocoli pocas observaciones
brocoli <- subset (prod.20.fh, culti =="BROCOLI")
brocoli$anho <- brocoli$anho - mean(brocoli$anho)
ggplot (brocoli, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.brocoli <- lmer(rendi ~ anho + (1|depa),REML=T, data = brocoli)
summary(lm.brocoli)
Anova(lm.brocoli)
plot(lm.brocoli)
ggplot(brocoli, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# lechuga
lechuga <- subset (prod.20.fh, culti =="LECHUGA")
lechuga$anho <- lechuga$anho - mean(lechuga$anho)
ggplot (lechuga, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.lechuga <- lmer(rendi ~ anho + (1|depa),REML=T, data = lechuga)
summary(lm.lechuga)
Anova(lm.lechuga)
r.squaredGLMM(lm.lechuga)
plot(lm.lechuga)
tab_model(lm.lechuga)
report(lm.lechuga)
ggplot(lechuga, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# apio pocas observaciones
apio <- subset (prod.20.fh, culti =="APIO")
apio$anho <- apio$anho - mean(apio$anho)
ggplot (apio, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.apio <- lmer(rendi ~ anho + (1|depa),REML=T, data = apio)
summary(lm.apio)
Anova(lm.apio)
r.squaredGLMM(lm.apio)
plot(lm.apio)
ggplot(apio, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# papaya
papaya <- subset (prod.20.fh, culti =="PAPAYA")
papaya$anho <- papaya$anho - mean(papaya$anho)
ggplot (papaya, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.papaya <- lmer(rendi ~ anho + (1|depa),REML=T, data = papaya)
summary(lm.papaya)
Anova(lm.papaya)
plot(lm.papaya)
tab_model(lm.papaya)
report(lm.papaya)
r.squaredGLMM(lm.papaya)
ggplot(papaya, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# fresa pocas observaciones
fresa <- subset (prod.20.fh, culti =="FRESA")
fresa$anho <- fresa$anho - mean(fresa$anho)
ggplot (fresa, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.fresa <- lmer(rendi ~ anho + (1|depa),REML=T, data = fresa)
summary(lm.fresa)
Anova(lm.fresa)
plot(lm.fresa)
tab_model(lm.fresa)
report(lm.fresa)
r.squaredGLMM(lm.fresa)
ggplot(fresa, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# pomelo pocas observaciones
pomelo <- subset (prod.20.fh, culti =="POMELO")
pomelo$anho <- pomelo$anho - mean(pomelo$anho)
ggplot (pomelo, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.pomelo <- lmer(rendi ~ anho + (1|depa),REML=T, data = pomelo)
summary(lm.pomelo)
Anova(lm.pomelo)
plot(lm.pomelo)
ggplot(pomelo, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")
  

# pinha
pinha <- subset (prod.20.fh, culti =="PINHA")
pinha$anho <- pinha$anho - mean(pinha$anho)
ggplot (pinha, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.pinha <- lmer(rendi ~ anho + (1|depa),REML=T, data = pinha)
summary(lm.pinha)
Anova(lm.pinha)
plot(lm.pinha)
tab_model(lm.pinha)
report(lm.pinha)
r.squaredGLMM(lm.pinha)
ggplot(pinha, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# maracuya
maracuya <- subset (prod.20.fh, culti =="MARACUYA")
maracuya$anho <- maracuya$anho - mean(maracuya$anho)
ggplot (maracuya, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.maracuya <- lmer(rendi ~ anho + (1|depa),REML=T, data = maracuya)
summary(lm.maracuya)
Anova(lm.maracuya)
r.squaredGLMM(lm.maracuya)
plot(lm.maracuya)
tab_model(lm.maracuya)
report(lm.maracuya)
ggplot(maracuya, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# melon
melon <- subset (prod.20.fh, culti =="MELON")
melon$anho <- melon$anho - mean(melon$anho)
ggplot (melon, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.melon <- lmer(rendi ~ anho + (1|depa),REML=T, data = melon)
summary(lm.melon)
Anova(lm.melon)
r.squaredGLMM(lm.melon)
plot(lm.melon)
tab_model(lm.melon)
report(lm.melon)
ggplot(melon, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# badea pocas observaciones
badea <- subset (prod.20.fh, culti =="BADEA")
badea$anho <- badea$anho - mean(badea$anho)
ggplot (badea, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.badea <- lmer(rendi ~ anho + (1|depa),REML=T, data = badea)
summary(lm.badea)
Anova(lm.badea)
plot(lm.badea)
ggplot(badea, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# lima
lima <- subset (prod.20.fh, culti =="LIMA")
lima$anho <- lima$anho - mean(lima$anho)
ggplot (lima, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.lima <- lmer(rendi ~ anho + (1|depa),REML=T, data = lima)
summary(lm.lima)
Anova(lm.lima)
r.squaredGLMM(lm.lima)
plot(lm.lima)
tab_model(lm.lima)
report(lm.lima)
ggplot(lima, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# patilla pocas observaciones
patilla <- subset (prod.20.fh, culti =="PATILLA")
patilla$anho <- patilla$anho - mean(patilla$anho)
ggplot (patilla, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.patilla <- lmer(rendi ~ anho + (1|depa),REML=T, data = patilla)
summary(lm.patilla)
Anova(lm.patilla)
plot(lm.patilla)
ggplot(patilla, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# citricos
citricos <- subset (prod.20.fh, culti =="CITRICOS")
citricos$anho <- citricos$anho - mean(citricos$anho)
ggplot (citricos, aes(rendi)) + 
  geom_density(binwidth=5, colour="grey80", fill="grey80", alpha=1) + 
  theme_bw() + xlab (expression(paste('Rendimiento'~(Ton~x~ha^-1))))
lm.citricos <- lmer(rendi ~ anho + (1|depa),REML=T, data = citricos)
summary(lm.citricos)
Anova(lm.citricos)
plot(lm.citricos)
tab_model(lm.citricos)
report(lm.citricos)
r.squaredGLMM(lm.citricos)
ggplot(citricos, aes(anho, rendi, color=rendi, alpha=0.5)) +
  geom_point(shape = 16, size = 2) +
  theme_bw() +
  scale_color_gradient(low = "#CCCCCC", high = "#000000") +
  scale_alpha(range = c(0.2, 0.8)) +
  facet_wrap(~ depa, nrow = 4) +
  geom_smooth(method = "lm", color="blue", size=0.5) +
  ylab (expression(paste('Rendimiento'~(Ton~x~ha^-1)))) +
  coord_cartesian(ylim = c(0, 40)) + 
  theme (strip.text.x = element_text (face="bold", size=8, angle=0), 
         strip.background = element_rect(fill="grey95"),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")


## subset by crop y aplicacion del modelo: año:random - depa:fixed
# coliflor pocas observaciones
lm.coliflor.depa <- lmer(rendi ~ depa + (1|anho), REML=T,data = coliflor)
summary(lm.coliflor.depa)
plot(lm.coliflor.depa)


# zanahoria
lm.zanahoria.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = zanahoria)
summary(lm.zanahoria.depa)
Anova(lm.zanahoria.depa)
r.squaredGLMM(lm.zanahoria.depa)
plot(lm.zanahoria.depa)
tab_model(lm.zanahoria.depa)
report(lm.zanahoria.depa)

# puerro (pocas observaciones)
lm.puerro.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = puerro)
summary(lm.puerro.depa)
Anova(lm.puerro.depa)
r.squaredGLMM(lm.puerro.depa)
plot(lm.puerro.depa)


# repollo
lm.repollo.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = repollo)
summary(lm.repollo.depa)
Anova(lm.repollo.depa)
r.squaredGLMM(lm.repollo.depa)
plot(lm.repollo.depa)
tab_model(lm.repollo.depa)
report(lm.repollo.depa)

# tomate
lm.tomate.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = tomate)
summary(lm.tomate.depa)
Anova(lm.tomate.depa)
r.squaredGLMM(lm.tomate.depa)
plot(lm.tomate.depa)
tab_model(lm.tomate.depa)
report(lm.tomate.depa)

# remolacha pocas observaciones
lm.remolacha.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = remolacha)
summary(lm.remolacha.depa)
Anova(lm.remolacha.depa)
plot(lm.remolacha.depa)


# cebolla
lm.cebolla.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = cebolla)
summary(lm.cebolla.depa)
Anova(lm.cebolla.depa)
r.squaredGLMM(lm.cebolla.depa)
plot(lm.cebolla.depa)
tab_model(lm.cebolla.depa)
report(lm.cebolla.depa)


# brocoli pocas observaciones
lm.brocoli.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = brocoli)
summary(lm.brocoli.depa)
Anova(lm.brocoli.depa)
plot(lm.brocoli.depa)


# lechuga
lm.lechuga.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = lechuga)
summary(lm.lechuga.depa)
Anova(lm.lechuga.depa)
r.squaredGLMM(lm.lechuga.depa)
plot(lm.lechuga.depa)
tab_model(lm.lechuga.depa)
report(lm.lechuga.depa)

# apio pocas observaciones
lm.apio.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = apio)
summary(lm.apio.depa)
Anova(lm.apio.depa)
r.squaredGLMM(lm.apio.depa)
plot(lm.apio.depa)

# papaya
lm.papaya.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = papaya)
summary(lm.papaya.depa)
Anova(lm.papaya.depa)
plot(lm.papaya.depa)
tab_model(lm.papaya.depa)
report(lm.papaya.depa)
r.squaredGLMM(lm.papaya.depa)


# fresa pocas observaciones
lm.fresa.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = fresa)
summary(lm.fresa.depa)
Anova(lm.fresa.depa)
plot(lm.fresa.depa)
tab_model(lm.fresa.depa)
report(lm.fresa.depa)
r.squaredGLMM(lm.fresa.depa)

# pomelo pocas observaciones
lm.pomelo.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = pomelo)
summary(lm.pomelo.depa)
Anova(lm.pomelo.depa)
plot(lm.pomelo.depa)

# pinha
lm.pinha.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = pinha)
summary(lm.pinha.depa)
Anova(lm.pinha.depa)
plot(lm.pinha.depa)
tab_model(lm.pinha.depa)
report(lm.pinha.depa)
r.squaredGLMM(lm.pinha.depa)

# maracuya
lm.maracuya.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = maracuya)
summary(lm.maracuya.depa)
Anova(lm.maracuya.depa)
r.squaredGLMM(lm.maracuya.depa)
plot(lm.maracuya.depa)
tab_model(lm.maracuya.depa)
report(lm.maracuya.depa)

# melon
lm.melon.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = melon)
summary(lm.melon.depa)
Anova(lm.melon.depa)
r.squaredGLMM(lm.melon.depa)
plot(lm.melon.depa)
tab_model(lm.melon.depa)
report(lm.melon.depa)

# badea pocas observaciones
lm.badea.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = badea)
summary(lm.badea.depa)
Anova(lm.badea.depa)
plot(lm.badea.depa)

# lima
lm.lima.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = lima)
summary(lm.lima.depa)
Anova(lm.lima.depa)
r.squaredGLMM(lm.lima.depa)
plot(lm.lima.depa)
tab_model(lm.lima.depa)
report(lm.lima.depa)

# patilla pocas observaciones

lm.patilla.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = patilla)
summary(lm.patilla.depa)
Anova(lm.patilla.depa)
plot(lm.patilla.depa)


# citricos
lm.citricos.depa <- lmer(rendi ~ depa + (1|anho),REML=T, data = citricos)
summary(lm.citricos.depa)
Anova(lm.citricos.depa)
plot(lm.citricos.depa)
tab_model(lm.citricos.depa)
report(lm.citricos.depa)
r.squaredGLMM(lm.citricos.depa)

#mejores <- bind_rows (cebolla,citricos,lechuga,lima,maracuya,
                      #melon,papaya,pinha,repollo,tomate,zanahoria)


###################################################
## Comparacion por departamentos mejores cadenas ##
###################################################
library ("scales")
library ("Hmisc")
library ("dplyr")
library ("reshape2")
library("ggplot2")
library ("RColorBrewer")
library("tidyr")
library("grid") # cargar paquete para crear grafica con varias figuras
library("gridExtra") # cargar paquete para crear grafica con varias figuras
library ("viridis")

getwd()
setwd("~/Google Drive/Mi unidad/2. ITA/R files mac")
best <- read.delim ("mejores.txt", dec=",")
source("Function se.r")
str(best)
best$depa <- as.factor (best$depa)
best$muni <- as.factor (best$muni)
best$gr.culti <- as.factor (best$gr.culti)
best$culti <- as.factor (best$culti) 

levels (best$culti) <- c("Onion","Other Citrus", 
                          "Lettuce", "Lime", "Passion Fr", "Melon", 
                          "Papaya", "Pineapple","Cabagge","Tomato", 
                          "Carrot")

levels (best$depa) <- c("AMAZ","ANTI","ARAU","ATLA",               
                       "BOLI","BOYA","CALD","CAQU",                 
                       "CASA","CAUC","CESA","CHOC",                   
                       "CORD","CUNDI","GUAI","GUAV",                
                       "HUIL","GUAJ","MAGD","META",
                       "NARI","NO.SA","PUTU","QUIN",                 
                       "RISA","SAYP",
                       "SANT","SUCR","TOLI","VALL",         
                      "VAUP", "VICH")

reorder_within <- function(x, by, within, fun = mean, sep = "___", ...) {
  new_x <- paste(x, within, sep = sep)
  stats::reorder(new_x, by, FUN = fun)
}


scale_x_reordered <- function(..., sep = "___") {
  reg <- paste0(sep, ".+$")
  ggplot2::scale_x_discrete(labels = function(x) gsub(reg, "", x), ...)
}


se.best <- summarySE (best, measurevar = "rendi", 
                      groupvars = c("depa", "culti"), na.rm = TRUE)
   

ggplot(best, aes(x=reorder_within(culti, rendi, depa, mean), 
                 y=rendi, fill=culti)) + 
  geom_boxplot(outlier.size = 0.7, alpha=0.6) +
  # geom_jitter(color="black", size=0.2, alpha=0.3) +
  stat_summary(fun.y=mean, geom="point", col="Black", 
               shape = 10, size=2, position=position_dodge(width = 0.7)) +
  facet_wrap(vars(depa), nrow=3, scales="free_x") +
  scale_fill_brewer (name="Crops", palette="Paired") +
  theme_bw() + 
  scale_x_reordered() +
  ylab (expression(paste('Yield'~(Ton~x~ha^-1)))) + 
  xlab (expression(paste(''))) +
  theme (axis.title = element_text (size=14), 
         axis.text = element_text(size=12), 
         axis.text.x = element_blank(),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "bottom")

# New fig option 2
ggplot(best, aes(x=reorder_within(depa, rendi, culti, mean), 
                 y=rendi)) + 
  geom_boxplot(color="black", fill="Lightblue", alpha=1, 
               outlier.size = 0.7,) +
  #geom_jitter(color="black", size=0.2, alpha=0.3) +
  stat_summary(fun.y=mean, geom="point", col="Black", 
               shape = 10, size=2, position=position_dodge(width = 0.7)) +
  facet_wrap(vars(culti), nrow=3, scales="free_x") +
  #scale_fill_brewer (name="", palette="Paired") +
  theme_bw() + 
  scale_x_reordered() +
  ylab (expression(paste('Yield'~(Ton~x~ha^-1)))) + 
  xlab (expression(paste(''))) +
  theme (axis.title = element_text (size=14), 
         axis.text = element_text(size=12), 
         axis.text.x = element_text(size=7, angle=90),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

## Analisis de los promedios

se.best <- filter (se.best, rendi!=0)
se.best <- se.best[complete.cases(se.best), ]

ggplot(se.best, aes(x=reorder_within(culti, rendi, depa, mean), y=rendi, 
                    fill=culti)) + 
  geom_bar(position = position_dodge(), stat = "identity", 
          width = 0.8, colour = "black") +
  geom_errorbar (aes(ymin=se.best$rendi-se.best$se, 
  ymax=se.best$rendi+se.best$se), 
  position = position_dodge (0.1), 
  linetype ="solid", colour="black",
  size=0.3, width=0.5) +
  scale_fill_brewer (name="Crops", palette="Paired") +
  facet_wrap(vars(depa), nrow=3, scales="free_x") +
  theme_bw() + 
  ylab (expression(paste('Yield'~(Ton~x~ha^-1)))) + 
  xlab (expression(paste(''))) +
  theme (axis.title = element_text (size=14), 
         axis.text = element_text(size=12), 
         axis.text.x = element_blank (),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "bottom")

# New fig option1
ggplot(se.best, aes(x=reorder_within(depa, rendi, culti, mean), y=rendi, 
                    fill="Lightblue")) + 
  geom_bar(position = position_dodge(), stat = "identity", 
           width = 0.8, colour = "black", fill="Lightblue") +
  geom_errorbar (aes(ymin=se.best$rendi-se.best$se, 
                     ymax=se.best$rendi+se.best$se), 
                 position = position_dodge (0.1), 
                 linetype ="solid", colour="black",
                 size=0.3, width=0.5) +
  #scale_fill_brewer (name="Crops", palette="Paired") +
  facet_wrap(vars(culti), nrow=3, scales="free_x") +
  theme_bw() + 
  ylab (expression(paste('Yield'~(Ton~x~ha^-1)))) + 
  xlab (expression(paste(''))) +
  scale_x_reordered() +
  theme (strip.text.x = element_text (face="bold", size=11, angle=0),
         axis.title = element_text (size=14), 
         axis.text = element_text(size=12), 
         axis.text.x = element_text(size=7, angle=90),
         panel.grid.major.x=element_blank(),
         panel.grid.minor.x=element_blank(),
         legend.position = "none")

# ANOVA 
# Analisis por cultivo
library("agricolae")
library ("car")

levels (best$culti)

onion <-filter(best,culti== "Onion")
other <-filter(best,culti== "Other Citrus")
cabba <-filter(best,culti== "Cabagge")
lettuce <-filter(best,culti== "Lettuce")
lime <-filter(best,culti== "Lime")
passion <-filter(best,culti== "Passion Fr")
melon <-filter(best,culti== "Melon")
papaya <-filter(best,culti== "Papaya")
pine <-filter(best,culti== "Pineapple")
tomato <-filter(best,culti== "Tomato")
carrot <-filter(best,culti== "Carrot")

onion.aov <- aov (rendi ~ depa*anho, data=onion)
Anova (onion.aov, type="III", singular.ok=T)
HSD.test(onion.aov, "depa",console=TRUE)

other.aov<- aov (rendi ~ depa*anho, data=other)
Anova (other.aov, type="III", singular.ok=T)
HSD.test(other.aov, "depa",console=TRUE)

cabba.aov <- aov (rendi ~ depa*anho, data=cabba)
Anova (cauli.aov, type="III", singular.ok=T)
HSD.test(cauli.aov, "depa",console=TRUE)

lettuce.aov <- aov (rendi ~ depa*anho, data=lettuce)
Anova (lettuce.aov, type="III", singular.ok=T)
HSD.test(lettuce.aov, "depa",console=TRUE)

lime.aov <- aov (rendi ~ depa*anho, data=lime)
Anova (lime.aov, type="III", singular.ok=T)
HSD.test(lime.aov, "depa",console=TRUE)

passion.aov <- aov (rendi ~ depa*anho, data=passion)
Anova (passion.aov, type="III", singular.ok=T)
HSD.test(passion.aov, "depa",console=TRUE)

melon.aov <- aov (rendi ~ depa*anho, data=melon)
Anova (melon.aov, type="III", singular.ok=T)
HSD.test(melon.aov, "depa",console=TRUE)

papaya.aov <- aov (rendi ~ depa*anho, data=papaya)
Anova (papaya.aov, type="III", singular.ok=T)
HSD.test(papaya.aov, "depa",console=TRUE)

pine.aov <- aov (rendi ~ depa*anho, data=pine)
Anova (pine.aov, type="III", singular.ok=T)
HSD.test(pine.aov, "depa",console=TRUE)

tomato.aov <- aov (rendi ~ depa*anho, data=tomato)
Anova (tomato.aov, type="III", singular.ok=T)
HSD.test(tomato.aov, "depa",console=TRUE)

carrot.aov <- aov (rendi ~ depa*anho, data=carrot)
Anova (carrot.aov, type="III", singular.ok=T)
HSD.test(carrot.aov, "depa",console=TRUE)
